unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ScktComp, StdCtrls, XPMan, FileCtrl, ComCtrls, Menus, ShellAPI;

type
  TForm1 = class(TForm)
    Client: TClientSocket;
    FileSocket: TClientSocket;
    XPManifest1: TXPManifest;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    DriveComboBox1: TDriveComboBox;
    GroupBox4: TGroupBox;
    FilterComboBox1: TFilterComboBox;
    GroupBox5: TGroupBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    Server: TServerSocket;
    ProgressBar1: TProgressBar;
    FileSocketServer: TServerSocket;
    GroupBox6: TGroupBox;
    Memo1: TMemo;
    GroupBox7: TGroupBox;
    Label4: TLabel;
    Edit3: TEdit;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button1: TButton;
    Label3: TLabel;
    FileSize: TEdit;
    Label5: TLabel;
    FileName: TEdit;
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    About1: TMenuItem;
    Createdby1: TMenuItem;
    Contact1: TMenuItem;
    Why1: TMenuItem;
    Quit1: TMenuItem;
    Quit2: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure ClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure FileSocketConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure FormCreate(Sender: TObject);
    procedure ClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientDisconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure FileSocketDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure ServerClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure FileSocketServerClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Log(NewText : String);
    procedure Status(NewText : String);
    procedure ServerListen(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ServerAccept(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure FileSocketServerListen(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure FileSocketServerClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure FileSocketServerClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure FileSocketServerAccept(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure FileSocketServerClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure ClientConnecting(Sender: TObject; Socket: TCustomWinSocket);
    procedure About1Click(Sender: TObject);
    procedure Createdby1Click(Sender: TObject);
    procedure Contact1Click(Sender: TObject);
    procedure Why1Click(Sender: TObject);
    procedure Quit1Click(Sender: TObject);
    procedure Quit2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Stream : TFileStream;
implementation

uses Unit2;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
client.Close;
Status('Disconnected.');
end;

procedure TForm1.ClientRead(Sender: TObject; Socket: TCustomWinSocket);
var
Data : String;
begin
Data := Socket.ReceiveText;
If Data = '!DONE' then
begin
memo1.lines.add('File transfer was successful.');
FileSocket.Close;
end;
end;

procedure TForm1.FileSocketConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
FName : String;
begin
memo1.lines.add('File transfer socket connected.');
FName :=  filelistbox1.FileName;
FileSocket.Socket.SendStream(TFileStream.Create(Fname,fmopenread));
memo1.Lines.add('Sending file ' + ExtractFileName(FName) + '...');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
memo1.lines.clear;
Memo1.Lines.Add('File Transfer sucessfully started on ' + DateToStr(Date) + ' at ' + FormatDateTime('h:nn ampm',Time) + '.');
//FormatDateTime('h:nn ampm',Time)
//that h = the hour with no 0
// nn = the minutes with a 0 in front.
//e.x. 12:03
// ampm makes it AM or PM 12 hour clock
//and time is the string you are formatting
end;

procedure TForm1.ClientError(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
memo1.lines.add('Problem with connection. Please try again. Error Code ' + inttostr(ErrorCode) +'.');
edit1.Enabled := true;
edit2.Enabled := true;
ErrorCode := 0;
end;

procedure TForm1.ClientConnect(Sender: TObject; Socket: TCustomWinSocket);
begin
status('Connected.');
memo1.Lines.Add('Sucessfully connected to ' + socket.RemoteAddress + '.');
end;

procedure TForm1.ClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
edit1.Enabled := true;
edit2.Enabled := true;
memo1.lines.add('Client socket dissconected.');
end;

procedure TForm1.FileSocketDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
memo1.lines.add('File transfer socket closed.');
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
server.Close;
edit3.Enabled := false;
server.Port := strtoint(edit3.text);
Log('Attempting to open the server...');
server.Open;
end;


procedure TForm1.Button5Click(Sender: TObject);
begin
server.close;
edit3.enabled := true;
Log('Server closed. Clients cannot connect.');
Status('Disconnected.');
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
client.Close;
edit1.Enabled := false;
edit2.Enabled := false;
client.host := edit1.Text;
client.Port := strtoint(edit2.text);
client.Open;
memo1.Lines.add('Attempting to connect to ' + edit1.text + '...');
end;

procedure TForm1.Button7Click(Sender: TObject);
var
FName : string;
Size : integer;
begin
if (client.Active = true) and (filelistbox1.ItemIndex > -1) then begin
FName :=  filelistbox1.FileName;
Stream := TFileStream.Create(Fname,fmopenread);
Stream.Position := 0;
Size := Stream.Size;
memo1.Lines.add('Setting up the file transfer...');
memo1.lines.add('Sending file size for ' + ExtractFileName(Fname) + '...');
Client.Socket.SendText('!SIZE' + inttostr(Size));
filesize.Text := inttostr(Size);
Stream.Free;
sleep(2000);
Client.Socket.SendText('!FILE' + ExtractFileName(Fname));
memo1.lines.add('Sending file name for ' + ExtractFileName(Fname) + '...');
filename.Text := ExtractFileName(FName);
sleep(2000);
FileSocket.Host := edit1.text;
FileSocket.Open;
end;
end;

procedure TForm1.ServerClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
IncommingData, StrippedData, CommandName : String;
begin
progressbar1.position := 0;
IncommingData := Socket.ReceiveText;
StrippedData := copy(IncommingData,6,length(IncommingData));
CommandName := copy(IncommingData,0,5);
if CommandName = '!FILE' then
begin
Log('Incomming file name...');
Stream := TFileStream.Create(StrippedData, fmCREATE or fmopenwrite and fmsharedenywrite);
//TFileStream.Create(StrippedData, fmCREATE or fmOPENWRITE)
//basically what that is this
//flag fmCREATE = if the file exists, open it for write access
//if it doesnt, then create a new file
//flag fmOPENWRITE opens the fille for write access only
FileName.Text := StrippedData;
FileSocketServer.Port := 236;
FileSocketServer.Open;
end;
if CommandName = '!SIZE' then begin
Log('Incomming file size...');
FileSize.Text := StrippedData;
ProgressBar1.Max := strtoint(StrippedData);
progressbar1.min := 0;
end;
end;

procedure TForm1.FileSocketServerClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
buffer : array[0..999999] of char; //unsigned char
FilePath : string;
IncommingLen, RecievedLen : integer;
begin
FilePath := ExtractFilePath(Application.ExeName);
IncommingLen := socket.ReceiveLength;
//recieve the length of the bytes
while IncommingLen > 0 do
begin
RecievedLen := socket.ReceiveBuf(Buffer, Sizeof(Buffer));
//get the buffer with the bytes from the files
if RecievedLen <= 0 then begin
Break
//if there are no more bytes in the file then
//exit this while statement (break)
end else
Stream.Write(Buffer,RecievedLen);
ProgressBar1.StepBy(RecievedLen);
//if the buffer has data, write to the file
if Stream.Size >= strtoint(FileSize.Text) then
//if the new file is the same amount of bytes as
//the original then send the 'DONE' command to the client
begin
Server.Socket.Connections[0].SendText('!DONE');
log('File successfully recieved.');
Stream.Free;
filesize.Clear;
filename.Clear;
FileSocketServer.Close;
progressbar1.Position := 0;
break
end;
end;
end;

procedure TForm1.Log(NewText: String);
begin
memo1.Lines.Add(NewText);
end;

procedure TForm1.ServerListen(Sender: TObject; Socket: TCustomWinSocket);
begin
Status('Listening...');
Log('Server sucessfully opened. Clients can connect.');
end;

procedure TForm1.ServerClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
edit3.Enabled := true;
Log('Error with connection. Error code number ' + inttostr(ErrorCode));
ErrorCode := 0;
end;

procedure TForm1.ServerAccept(Sender: TObject; Socket: TCustomWinSocket);
begin
Log('New client successfully connected!');
end;

procedure TForm1.ServerClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
Log('Incomming connection from ' + socket.RemoteAddress + '.');
end;

procedure TForm1.ServerClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
edit3.enabled := true;
end;

procedure TForm1.FileSocketServerListen(Sender: TObject;
  Socket: TCustomWinSocket);
begin
Log('Opening file server socket...');
end;

procedure TForm1.FileSocketServerClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
Log('File server socket closed.');
end;

procedure TForm1.FileSocketServerClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
Log('File server socket error. Error code number ' + inttostr(ErrorCode) + '.');
ErrorCode := 0;
end;

procedure TForm1.FileSocketServerAccept(Sender: TObject;
  Socket: TCustomWinSocket);
begin
Log('Incomming file transfer...');
end;

procedure TForm1.FileSocketServerClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
Log('File server socket succesfully connected.');
end;

procedure TForm1.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
if Key in [#8, '0'..'9'] = false then
begin
key := #0;
end;
end;

procedure TForm1.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
if key in [#8,'0'..'9'] = false then
begin
key := #0;
end;
end;

procedure TForm1.Status(NewText: String);
begin
statusbar1.Panels[1].Text := NewText;
end;

procedure TForm1.ClientConnecting(Sender: TObject;
  Socket: TCustomWinSocket);
begin
status('Connecting...');
end;

procedure TForm1.About1Click(Sender: TObject);
begin
form2.ShowModal;
end;

procedure TForm1.Createdby1Click(Sender: TObject);
begin
messagebox(handle,'File Transfer is written by Ian Fain a.k.a. Phase.','Created By',MB_ICONINFORMATION);
end;

procedure TForm1.Contact1Click(Sender: TObject);
begin
messagebox(handle,'You can contact me by AIM on ''cold phase''.','File Transfer',MB_ICONINFORMATION);
end;

procedure TForm1.Why1Click(Sender: TObject);
begin
MessageBox(handle,'I wrote this program to make a good file transfer.','File transfer',MB_ICONWARNING);
end;

procedure TForm1.Quit1Click(Sender: TObject);
begin
ShellExecute(handle,'open','http://badram.com',nil,nil,SW_SHOW);
end;

procedure TForm1.Quit2Click(Sender: TObject);
begin
close;
end;

end.
